Sy = {
	version : '1.0'
};
Sy.ns = function() {
	var a = arguments,
		o = null,
		i,
		j,
		d,
		rt;
	for (i = 0; i < a.length; ++i) {
		d = a[i].split(".");
		rt = d[0];
		eval('if (typeof ' + rt + ' == "undefined"){' + rt + ' = {};}; o = ' + rt + ';');
		for (j = 1; j < d.length; ++j) {
			o[d[j]] = o[d[j]] || {};
			o = o[d[j]];
		}
	}
};

Sy.ns('app.error');
(function(error) {
	var error_ftl = '<div class="cz-bat"><div class="bat-img"><img src="img/no-network.gif"></div><p class="bat-txt"><%=msg%>，请点击重试。</p></div>';
	error.show = function(msg, func) {
		var _msg = (msg || '');
		var render = template.compile(error_ftl);
		var error_html = render({
			msg : _msg
		});
		$("body").html(error_html);
		if (func && typeof func == 'function') {
			$("body").tap(func);
		} else {
			$("body").tap(function() {
				location.reload();
			});
		}
	};
})(app.error);

Sy.ns('app.loadcss');
(function(loadcss) {
	/*
	* @function 动态加载css文件
	* @param {string} options.url -- css资源路径
	* @param {function} options.callback -- 加载后回调函数
	* @param {string} options.id -- link标签id
	*/
	loadcss.init = function(options) {
		var url = options.url,
			callback = typeof options.callback == "function" ? options.callback : function() {},
			id = options.id,
			node = document.createElement("link"),
			supportOnload = "onload" in node,
			isOldWebKit = +navigator.userAgent.replace(/.*(?:AppleWebKit|AndroidWebKit)\/?(\d+).*/i, "$1") < 536, // webkit旧内核做特殊处理
			protectNum = 300000; // 阈值10分钟，一秒钟执行pollCss 500次
		node.rel = "stylesheet";
		node.type = "text/css";
		node.href = url;
		if (typeof id !== "undefined") {
			node.id = id;
		}
		document.getElementsByTagName("head")[0].appendChild(node);
		// for Old WebKit and Old Firefox
		if (isOldWebKit || !supportOnload) {
			// Begin after node insertion
			setTimeout(function() {
				pollCss(node, callback, 0);
			}, 1);
			return;
		}
		if (supportOnload) {
			node.onload = onload;
			node.onerror = function() {
				// 加载失败(404)
				onload();
			}
		} else {
			node.onreadystatechange = function() {
				if (/loaded|complete/.test(node.readyState)) {
					onload();
				}
			}
		}
		function onload() {
			// 确保只跑一次下载操作
			node.onload = node.onerror = node.onreadystatechange = null;
			// 清空node引用，在低版本IE，不清除会造成内存泄露
			node = null;
			callback();
		}
		// 循环判断css是否已加载成功
		/*
		* @param node -- link节点
		* @param callback -- 回调函数
		* @param step -- 计步器，避免无限循环
		*/
		function pollCss(node, callback, step) {
			var sheet = node.sheet,
				isLoaded;
			step += 1;
			// 保护，大于10分钟，则不再轮询
			if (step > protectNum) {
				isLoaded = true;

				// 清空node引用
				node = null;
				callback();
				return;
			}
			if (isOldWebKit) {
				// for WebKit < 536
				if (sheet) {
					isLoaded = true;
				}
			} else if (sheet) {
				// for Firefox < 9.0
				try {
					if (sheet.cssRules) {
						isLoaded = true;
					}
				} catch (ex) {
					// 火狐特殊版本，通过特定值获知是否下载成功
					// The value of `ex.name` is changed from "NS_ERROR_DOM_SECURITY_ERR"
					// to "SecurityError" since Firefox 13.0. But Firefox is less than 9.0
					// in here, So it is ok to just rely on "NS_ERROR_DOM_SECURITY_ERR"
					if (ex.name === "NS_ERROR_DOM_SECURITY_ERR") {
						isLoaded = true;
					}
				}
			}
			setTimeout(function() {
				if (isLoaded) {
					// 延迟20ms是为了给下载的样式留够渲染的时间
					callback();
				} else {
					pollCss(node, callback, step);
				}
			}, 20);
		}
	};
})(app.loadcss);

jQuery.cachedScript = function(url, callback, cache) {
	try {
		$.ajax({
			type : 'GET',
			url : url,
			success : callback,
			error : function() {
				app.request.loadTimeout("数据加载失败");
			},
			dataType : 'script',
			ifModified : true,
			cache : cache
		});
	} catch (e) {
		app.request.loadTimeout("数据加载异常");
	}
};

jQuery.cachedStyle = function(url, callback, cache) {
	app.loadcss.init({
		url : url + (cache ? "" : "&t=" + new Date().getTime()),
		callback : callback,
		id : 'baseCss'
	});
};

Sy.ns('app.version');
Sy.ns('app.request');
(function(request) {
	var req = {};
	var loadeds = 0;
	var resLoadTime = 0;

	function loadedCallback() {
		loadeds = loadeds + 1;
		if (loadeds == 3) {
			clearTimeout(resLoadTime);
			eval('app.page.' + (req['pg'] ? req['pg'] + "." : "") + req['act'] + '.init(req)');
		}
	}

	request.loadTimeout = function(msg) {
		loadeds = 99;
		clearTimeout(resLoadTime);
		app.error.show(msg);
	};

	request.initHead = function() {
		// check url has package
		req = {};
		window.location.search.substr(1).replace(/(\w+)=([^;]+)/ig, function(a, b, c) {
			req[b] = decodeURI(c);
		});

		// init loadeds to 0
		loadeds = 0;
		// load timeout handle
		resLoadTime = setTimeout("app.request.loadTimeout('网络不给力')", 10000);

		// load remote base css
		$.cachedStyle(app.version.remoteUrl + "/app_resources/" + app.version.versionCode + "/style/base.css?v=" + app.version.pageVersion, function() {
			loadedCallback();
		}, app.version.formal);

		// load remote common js
		$.cachedScript(app.version.remoteUrl + "/app_resources/" + app.version.versionCode + "/js/common.js?v=" + app.version.pageVersion, function() {
			loadedCallback();
		}, app.version.formal);

		// load romte page js
		$.cachedScript(app.version.remoteUrl + "/app_resources/" + app.version.versionCode + "/js/" + (req['pg'] ? req['pg'] + "/" : "") + req['act'] + ".js?v=" + app.version.pageVersion, function() {
			loadedCallback();
		}, app.version.formal);
	};

	request.loadResource = function() {
		// load version plugin
		syapp.version.getInfo(function(info) {
			app.version = info;
			request.initHead();
		});
	};
})(app.request);

document.addEventListener('deviceready', app.request.loadResource, false);